import {
    decryptChildJsonData_ECB,
    decryptData_ECB, decryptData_ECB_YM,
    decryptListData_ECB, decryptListData_ECB_YM,
    decryptOtherJsonData_ECB, decryptUrgentNoticeData_ECB
} from '@/api/tool/sm4'
import Log from "@/pages/Log/Log";
export default {
    data() {
        return {
            queryData: {
                page: 1,   //表格当前页
                rows: 10,   //表格每页记录数
            },

            tableData: {
                listLoading: false,  //表格数据是否加载
                datas: [],  //表格数据
                datasIsNoYm: [],  //表格数据
                total: 0,  //表格总记录数
            },

            defaultLogic: {
                cancel: () => {
                    this.dialogData.dialogVisible = false
                },
                submit: this.formSubmit
            },
            dialogData: {
                title: '',   //弹出框标题
                dialogVisible: false,  //弹出框是否显示
                formLoading: false,    //弹出框内表单是否加载
            },
            formData: {},//表单数据
        }
    },
    computed: {
        defaultNum() {
            return (this.queryData.page - 1) * this.queryData.rows;
        }
    },
    methods: {
        //将参数与query合并
        setQueryData(val) {
            Object.assign(this.queryData, val);
            // Object.assign(this.queryData1, val);
        },
        //查询(根据条件和页数)
        query(page) {

            this.queryData.page = page;
            // console.log(page,time)
            // if (time) {
            //     this.queryData.startTime = time[0];
            //     this.queryData.endTime = time[1];
            // }
            // else{
            //     delete this.queryData.startTime;
            //     delete this.queryData.endTime;
            // }
            if(this.queryData.startTime||this.queryData.endTime)
            {
                 if(!(this.queryData.startTime&&this.queryData.endTime))
                 {
                     this.$message({ message: '请同时选择开始日期和结束日期', type: 'error' });
                     return false;
                 }
            }else
            {
                    delete this.queryData.startTime;
                    delete this.queryData.endTime;
            }
            this.loadTableData();
        },

        //加载列表(根据条件)
        async loadTableData() {
            let type = null;
            const router = this.$route.path.split('/');
            if(router[2]==='info'){
                type = 'info'
            }else if(router[2]==='visit'){
                type = 'visit'
            }else if(router[2]==='infoStatistics'){
                type = 'value'
            }else if(router[2]==='family'){
                type = 'family'
            }else if(router[2]==='UrgentNotice'){
                type = 'UrgentNotice'
            }
            this.tableData.listLoading = true;
            const result = await this.listForPage(this.queryData);
            this.tableData.listLoading = false;
            if (result.code == 0) {
                this.tableData.datas = result.data.list;
                this.tableData.total = result.data.count;
                this.tableData.nowdaytotal = result.data.nowdaytotal;
                this.tableData.fidCount=result.data.fidCount;
                if(type === 'info'){
                    // decryptListData_ECB(this.tableData.datas,["name","phone","idNumber","partnerName","partnerIdNumber","mainLookName","mainLookPhone"])

                    decryptChildJsonData_ECB(this.tableData.datas);
                    decryptOtherJsonData_ECB(this.tableData.datas);

                    // 创建原数组的深拷贝，因为对原有数组进行了不可逆操作，浅拷贝不行。
                    const datasDeepCopy1 = JSON.parse(JSON.stringify(this.tableData.datas));
                    const datasDeepCopy0 = JSON.parse(JSON.stringify(this.tableData.datas));

                    this.tableData.datas = decryptListData_ECB_YM(datasDeepCopy1, ["name", "phone", "idNumber", "partnerName", "partnerIdNumber", "mainLookName", "mainLookPhone"], [1, 3, 2, 1, 3, 1, 2], '1');
                    this.tableData.datasIsNoYm = decryptListData_ECB_YM(datasDeepCopy0,["name","phone","idNumber","partnerName","partnerIdNumber","mainLookName","mainLookPhone"],[1,3,2,1,3,1,2],'0')

                }else if(type === 'value'){

                    const datasDeepCopy1 = JSON.parse(JSON.stringify(this.tableData.datas));
                    const datasDeepCopy0 = JSON.parse(JSON.stringify(this.tableData.datas));

                    this.tableData.datas = decryptListData_ECB_YM(datasDeepCopy1,["userName"],[1],'1')
                    this.tableData.datasIsNoYm = decryptListData_ECB_YM(datasDeepCopy0,["userName"],[1],'0')
                }else if(type === 'family'){
                    // decryptListData_ECB(result.data.list,["userName","oldInfo","oldIdNumber"])
                    decryptListData_ECB(result.data.list,["userName","oldInfo","oldIdNumber"],[1,1,2])
                }else if(type === 'UrgentNotice'){
                    decryptUrgentNoticeData_ECB(result.data.list)
                }

            }
        },
        //删除提示
        handleDel(row) {
            this.$confirm('确认删除该记录吗?', '提示', {
                type: 'warning'
            }).then(() => {
                this.deleteOne(row._id);
            }).catch(() => {
            });
        },
        //删除(根据id)
        async deleteOne(id) {
            const result = await this.delete({ id });
            if (result.code == 0) {
                this.$message({ message: '删除成功', type: 'success' });
                this.loadTableData();
            }
        },

        //添加或者编辑
        async handleAddAndUpt(row, title) {
            if (this.loadListData) {
                this.loadListData();
            }
            if (title) {
                this.dialogData.title = title;
            } else {
                this.dialogData.title = row._id ? "编辑" : "新增";
            }
            this.dialogData.dialogVisible = true;
            if (row._id) {
                this.dialogData.formLoading = true;
                const result = await this.findOne({ id: row._id });
                // decryptData_ECB(result, ["userName", "phone", "idCardNumber"]);
                decryptData_ECB_YM(result, ["userName", "phone", "idCardNumber"],[1,3,2]);
                this.dialogData.formLoading = false;
                if (result.code == 0) {
                    this.formData = result.data;
                }
            }
        },
        //添加或者编辑的提交
        async formSubmit() {
            if (!this.$refs.test.check()) {
                return;
            }
            this.dialogData.formLoading = true;
            if (this.formData._id) {
                this.formData.id = this.formData._id;
                const result = await this.edit(this.formData);
                this.dialogData.formLoading = false;
                if (result.code == 0) {
                    this.$message({ message: '修改成功', type: 'success' });
                    this.loadTableData();
                    this.dialogData.dialogVisible = false;
                }
            } else {
                const result = await this.add(this.formData);
                this.dialogData.formLoading = false;
                if (result.code == 0) {
                    this.$message({ message: '添加成功', type: 'success' });
                    this.loadTableData();
                    this.dialogData.dialogVisible = false;
                }
            }
        },
        //关闭默认的dialog 时清空验证和数据
        closeDialog() {
            if (this.$refs.test) {
                this.$refs.test.clearCheck();
            }
            this.formData = {};
        },
    }
}

