import storageUtil from './storageUtil'
export default {
  defaultManagerId:'5d036441464ced1f1840204a',
  defaultPassword:'123456',
  numberRegex : /^[0-9]*$/,
  checkDeptName(obj, key) {
    return obj[key] ? obj[key].name : '';
  },

  foundFid(fitem,itemList,addressList){
    itemList.push(fitem[0].name);
    addressList.forEach(item=>{
      if(item._id==fitem[0].fid)
      {
        itemList.push(item.name);
        if(item.fid!=='0')
        {
          this.foundFid(item,itemList);
        }
      }
    });
    return itemList.reverse();
  },
  foundList(data){
    let  addressList=storageUtil.read("addressList")
    let items=addressList.filter(item=>{
      return  item.address==data;
    });
    if(items.length>0) {
      let itemList = [];
      return this.foundFid(items, itemList, addressList);
    }
    else
    {
      // window.history.back(-1);
    }
  },
  ownMenuList(result){
    let dbMenuArr = result.data.dbMenuArr;
    let roleMenu = result.data.roleMenu;
    let roleMenuIdArr = roleMenu.map((item) => {
      return item.id;
    });
    let ownMenuList = [];
    dbMenuArr.forEach((item) => {
      if (roleMenuIdArr.indexOf(item._id) != -1) {
        ownMenuList.push(item);
      }
    });
    return ownMenuList;
  },
  putTree(arr,child='_id',father='fid',mostKey='0',childKey='children'){
    let map = {};
    let resultArr = [];
    arr.forEach((item) => {
        item[childKey] = [];
        map[item[child]] = item;
    });
    arr.forEach((item) => {
      if (item[father]){
        if (item[father] == mostKey) {
          resultArr.push(item);
        } else {
          let parent = map[item[father]];
          parent[childKey].push(item);
        }
      }
    });
    return resultArr;
  },

  addRules(arr,propKey,rule){
    arr.find(item => {
      return item.prop == propKey;
    }).rules = rule;
  },

  formatName(name) {
    if (name === null || name === undefined) {
      return ' ';
    }
    if (name.length < 2 || name.length >= 10) {
      return ' ';
    } else if (name.length === 2) {
      return name[0] + '✱';
    }
    // 如果名字长度大于2位，保留首尾汉字，中间用星号替换
    const firstChar = name[0]; // 获取首位汉字
    const lastChar = name[name.length - 1]; // 获取末位汉字
    const middleStars = '✱'.repeat(name.length - 2); // 生成中间的星号字符串
    return firstChar + middleStars + lastChar;

  },
  formatPhone(phone) {
    if (phone === null || phone === undefined) {
      return ' ';
    }
    if (phone.length < 8 || phone.length >= 30) {
      // 长度小于2位，返回空格
      return ' ';
    } else if (phone.length === 8) {
      const firstChar = phone[0]; // 获取首位
      const secondChar = phone[1];
      const thirdChar = phone[2];
      const lastChar = phone[phone.length - 1];
      const last2Char = phone[phone.length - 2];
      const middleStars = '✱'.repeat(phone.length - 5); // 生成中间的星号字符串
      return firstChar + secondChar + thirdChar + middleStars + last2Char + lastChar;
    }
    const firstChar = phone[0]; // 获取首位
    const secondChar = phone[1];
    const thirdChar = phone[2];
    const lastChar = phone[phone.length - 1]; // 获取末位
    const last2Char = phone[phone.length - 2];
    const last3Char = phone[phone.length - 3];
    const last4Char = phone[phone.length - 4];
    const middleStars = '✱'.repeat(phone.length - 7); // 生成中间的星号字符串
    return firstChar + secondChar + thirdChar + middleStars + last4Char + last3Char + last2Char + lastChar;
  },
  formatIdCard(idCard) {
    if (idCard === null || idCard === undefined) {
      return ' ';
    }
    if (idCard.length === 15 || idCard.length === 18) {
      const firstChar = idCard[0]; // 获取首位
      const secondChar = idCard[1]; // 获取第二位
      const thirdChar = idCard[2]; // 获取第三位
      const first4Char = idCard[3]; // 获取第三位
      const first5Char = idCard[4]; // 获取第三位
      const first6Char = idCard[5]; // 获取第三位
      const lastChar = idCard[idCard.length - 1]; // 获取末位
      const last2Char = idCard[idCard.length - 2];
      const middleStars = '✱'.repeat(idCard.length - 8); // 生成中间的星号字符串
      return firstChar + secondChar + thirdChar + first4Char + first5Char + first6Char + middleStars + last2Char + lastChar;
    }
    return ' ';
  },
}
